function bg, x, a

; computes grey body dust spectrum 
;
; x : fltarr; wavelength (micron)
; a : model parameter. 3 values = compute a single beta model, 
;     5 values = two beta model
;
; MAMD, 22/08/2010


E_bg = a[0]
T_bg = a[1]
beta1 = a[2]
if (n_elements(a) eq 5) then begin
   lc = a[3]
   model = dblarr(n_elements(x))
   ind = where(x le lc, nbind, compl=compl, ncompl=ncompl)
   if (nbind gt 0) then model[ind] = 1.e20*E_bg*x[ind]^(-1*Beta1)*bnu_planck(x[ind], T_bg)
   if (ncompl gt 0) then begin
      beta2 = a[4]
      E2 = E_bg*lc^(beta2-beta1)
      model[compl] = 1.e20*E2*x[compl]^(-1*Beta2)*bnu_planck(x[compl], T_bg)
   endif
endif else begin
   model = 1.e20*E_bg*x^(-1*Beta1)*bnu_planck(x, T_bg)
endelse 

return, model

end

